#include <sys/types.h>
#include <sys/stat.h>
#if defined(__CYGWIN__)
# include <cygwin/stat.h>
# undef MD5SUM
# undef MATCHCNT
/*
 * the popen() is not supported in cygwin
 * for no hash comparison #undef MD5SUM
 */
#else
# include <linux/stat.h>
# define MD5SUM			"/usr/bin/md5sum"
# define MATCHCNT		32
/*
 * for the hash comparison #define MD5SUM
 */
#endif
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>
#include <time.h>

typedef
struct dupinfo
{
	/* keep the file stat as delivered by lstat()	*/
	loff_t          size;
	/* keep file names for later reference	*/
	char**name;
	/*
		finfo[1].ident ----v	/----->	finfo[1].name
				 dupinfo[1]
		finfo[2].ident ----A	\----->	finfo[2].name
	 */
	struct dupinfo*replace;
} dinfo;

typedef
struct fileinfo
{
	/* remember the file name including path	*/
	char*name;
	/* keep the file stat as delivered by lstat()	*/
	struct stat info;
	/* keep the hash number for later comparison	*/
	char*hash;
	/* file system priority (= arg line position)	*/
	int  prio;
	dinfo *ident;
} finfo;

#define basename(x)	((strrchr((x),'/')!=NULL)?strrchr((x),'/')+1:(x)) 
#define S_IRWXUGO       (S_IRWXU|S_IRWXG|S_IRWXO)
#define S_PERM(mode)    ((mode) & (ALLPERMS))

#include "version.h"
#define	MAXPATHLENGTH		4096
#define BLOCK			4096
#define INITIALFINFOCOUNT	20480
