%define name freedup
%define version 1.0
%define release 1
Name:				%{name}
Summary:			Links identical files to save file system space.
Version:			%{version}
Release:			%{release}
Copyright:			GPL
Packager:			Andreas Neuper<Andreas@Neuper.de>
Group:				Applications/File
Source:				http://software.neuper.de/%{name}/%{name}-%{version}-%{release}-src.tar.bz2
Buildarch:			i586
Vendor:				Andreas Neuper<Andreas@Neuper.de>
URL:				http://software.neuper.de/%{name}/
BuildRoot:			/tmp/%{name}-broot


%description
Freedup links identical files to save space. Freedup walks through one or 
more file system trees and links files. The Links are hard if the files 
belong to the same device and symbolic in case the devices differ. Switches
allow better adaption for automated usage. In interactive mode each set of
identical files may be treated differently.

For files that are generally read from and not written to, this provides
significant space savings particularily to multimedia content.


%prep
rm -rf ${RPM_BUILD_ROOT}

%setup


%install
if [ "$RPM_BUILD_ROOT" = "/tmp/freedup-broot" ]; then
	rm -rf $RPM_BUILD_ROOT
	INSTALLDIR=/usr/bin
	MANPAGEDIR=/usr/share/man
	install -d $RPM_BUILD_ROOT/$INSTALLDIR
	install -s -p -m 755 freedup $RPM_BUILD_ROOT/$INSTALLDIR/freedup
	install -d $RPM_BUILD_ROOT/$MANPAGEDIR/man1
	install -p -m 644 freedup.1.gz $RPM_BUILD_ROOT/$MANPAGEDIR/man1/freedup.1.gz
else
	echo Invalid Build root
	exit 1
fi
						
%clean
if [ "$RPM_BUILD_ROOT" = "/tmp/freedup-broot" ]; then
	rm -rf $RPM_BUILD_ROOT
else
	echo Invalid Build root
	exit 1
fi

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man1



%files
%defattr(-,root,root)
%attr(755,root,root)		/usr/bin/freedup
%doc				{TODO,README,ChangeLog}
%{_mandir}/man1/freedup.1.gz


%changelog
* Sat Oct 27 2007 Andreas Neuper <Andreas@Neuper.de>
- Enhancements in version 1.0
  + new interactive mode with full choice list
  + separated linking task into explicit function
  + option -i asks for manual replacement selections
  + options -in print file clusters like "fdupes -r"
  + partial code clean up
- Bugfixes 
  + avoid name collisions by generating temporary filenames
  + always check files for existance to avoid early termination
  + previously checked that permissions differ (instead of being identical)
  + previously checked that groups differ (instead of being identical)
  + previously checked that users differ (instead of being identical)
  + previously checked that times differ (instead of being identical)

* Tue Oct 09 2007 Andreas Neuper <Andreas@Neuper.de>
- Enhancements in version 0.9 freedup.c
  + added interactive mode (option -i) [this option is still beta]
  + added delete selections in interactive mode
  + added html documentation to archive
  + added tolerance to unavailable files on fopen() [Rel.2]
- Enhancements in version 0.9 Makefile
  + added definitions: INSTALLDIR, MANPAGEDIR, etc
  + added targets: tarball, install, clean, distclean
  + version and release are now defined in freedup.spec only
  + added test that tries all numeric options during interaction [Rel.2]
- Enhancements in version 0.9 freedup.spec
  + use install instead of cp

* Thu Oct 04 2007 Andreas Neuper <Andreas@Neuper.de>
- Enhancements in version 0.8
  + avoid linking empty files (new option -0)
  + avoid printing any information (new option -q)
  + updated man page to reflect all options
  + added test7 to check for correct handling of empty files
- Bugfixes 
  + use mode instead of size to determine file type
  + starting with release 1 (not with 0) 
  + added aditional file to distribution

* Tue Oct 02 2007 Andreas Neuper <Andreas@Neuper.de>
- Enhancements in version 0.7
  + compiles under cygwin (no hash  support with cygwin)
  + works for NTFS file systems (at least test cases worked)

* Fri Sep 21 2007 Andreas Neuper <Andreas@Neuper.de>
- Enhancements in version 0.6
  + MD5 hash scanning may be disabled by options now

* Wed Sep 12 2007 Andreas Neuper <Andreas@Neuper.de>
- Enhancements in version 0.5
  + exclude non-regular files from investigation using lstat
  + error handling for OS functions now with messages instead of asserts
  + corrected and completed some text messages
  + Tested 400000 multimedia files in upto 20 trees

* Wed Aug 29 2007 Andreas Neuper <Andreas@Neuper.de>
- Enhancements in version 0.4
  + now a single run should be sufficient in most cases
  + added -w to force symlinks instead of hardlinks
  + added -l to allow only hardlinks and no symlinks
  + first test comparing results for different trees
  + more structured web page
- Bugfixes 
  + no more overwriting of previously scanned trees 
  + comparision return values are not zero if additional tests fail
  + completed bug fixes from version 0.2

* Fri Aug 24 2007 Andreas Neuper <Andreas@Neuper.de>
- Enhancements in version 0.3
  + splitted user and group comparison into separate tests
- Bugfixes 
  + argument position is now less important than existing link count
    This was needed to avoid alternating link replacements
  + stop when number of changes gets constant :-(healing symptoms)
  + do not reset file counter when deciding to realloc()

* Tue Aug 21 2007 Andreas Neuper <Andreas@Neuper.de>
- Enhancements in version 0.2
  + call "find" only once
  + allow input from stdin 
  + some code cleaning
  + added man page
  + added more tests
  + improved Makefile
- Bugfixes 
  + added -a to getopt string
  + report correct version
  + corrected basename macro

* Thu Aug 16 2007 Andreas Neuper <Andreas@Neuper.de>
- Initial Release
